# HG changeset patch
# User Marko Njezic
# Date 1340789640 -7200
# Node ID 9b7d2f127674a14476bf2d92b0b77d018ad00336
# Parent  f339a01b6d615ae7efcbe91011a31a2e9113f29e
Prevent infinite loop when drawing block caret.

diff -r f339a01b6d61 -r 9b7d2f127674 src/Editor.cxx
--- a/src/Editor.cxx	Wed Jun 27 11:33:37 2012 +1000
+++ b/src/Editor.cxx	Wed Jun 27 11:34:00 2012 +0200
@@ -3235,7 +3235,10 @@
 		}
 		// Char shares horizontal space, update the numChars to draw
 		// Update posBefore to point to the prev char
-		posBefore = MovePositionOutsideChar(posBefore - 1, -1);
+		int posBeforeNew = MovePositionOutsideChar(posBefore - 1, -1);
+		if (posBeforeNew == posBefore)
+			break; // Prevent infinite loop
+		posBefore = posBeforeNew;
 		numCharsToDraw = posAfter - posBefore;
 		offsetFirstChar = offset - (posCaret - posBefore);
 	}